Subject: Re: Incorrect branch information after fetching (local branch != remote branch)

From: Junio C Hamano <[email-masked]>
Date: Mon, 02 May 2022 23:49:25 -0700

Bagas Sanjaya <[email-masked]> writes:

> On 5/3/22 12:51, Junio C Hamano wrote:
>> The verbose report left by "git fetch" tells us what branch they
>> have is used to update what branch we have, so I think this is
>> pretty much expected.
>> 
>> I am puzzled by your mention of 'net-next' (local).
>> 
>> You may have
>> 
>>     [branch "net-next"]
>>         remote = net-next
>> 	merge = master
>> 
>> and that is where your expectation on the local may be coming from,
>> but it wouldn't be all that relevant to "git fetch". The update of
>> the local branch will happen long after "git fetch" is done.
>> 
>
> Ah I see.
>
> So the left-hand side of verbose report (local branch) is actually
> the value of branch."net-next".merge, right?

Not really.  It comes from

	[remote "net-next"]
	    remote = https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net-next
	    fetch = refs/heads/*:refs/remotes/net-next/*

and the fact that the remote happens to have only one branch under
its refs/heads/ hierarchy.  Fetch does not care all that much about
"branch.*.merge" (which is what I said---the configuration is not
all that relevant to "git fetch").